/*
 * This file is part of Bielefeld Sensor Actuator Interface (BonSAI).
 *
 * Copyright(c) Frederic Siepmann
 * http://opensource.cit-ec.de/projects/bonsai
 *
 * This file may be licensed under the terms of of the
 * GNU Lesser General Public License Version 3 (the ``LGPL''),
 * or (at your option) any later version.
 *
 * Software distributed under the License is distributed
 * on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
 * express or implied. See the LGPL for the specific language
 * governing rights and limitations.
 *
 * You should have received a copy of the LGPL along with this
 * program. If not, go to http://www.gnu.org/licenses/lgpl.html
 * or write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * The development of this software was supported by the
 * Excellence Cluster EXC 277 Cognitive Interaction Technology.
 * The Excellence Cluster EXC 277 is a grant of the Deutsche
 * Forschungsgemeinschaft (DFG) in the context of the German
 * Excellence Initiative.
 *
 * Contributors: Leon Ziegler, Johannes Wienke, Norman Köster, Torben Töniges,
 *               Annika Rothert, Alexander Baumann, Marcel Dulisch, Maikel Linke,
 *               Marian Pohling, Lukas Twardon, Lukas Kettenbach
 */
/**
 * Provides middleware-independent sensor interfaces. These interfaces are
 * specializations of the normal {@link de.unibi.airobots.bonsai.core.Sensor}.
 * 
 * <p>
 * In contrast to actuators which always need a task specific interface, most
 * sensors are completely defined by the return type they provide. This
 * interface is already completely defined by
 * {@link de.unibi.airobots.bonsai.core.Sensor}. If possible this should be
 * used. However, sometimes this is not sufficient, e.g. if providing the sensor
 * data requires some actions beforehand or providing the data is costly so that
 * it must be enabled or disabled. In these cases the general pattern is to
 * create a middleware-independent but more specific interface for the sensor in
 * this package. A client code should only rely on this interface and not the
 * concrete middleware-specific implementation. 
 * </p>
 */
package de.unibi.airobots.bonsai.sensors;
